<!-- card ปฏิบัติราชการพิเศษ -->
<template>
  <q-card flat bordered class="col-12 q-px-lg q-py-md">
    <q-form ref="myForm">
      <ProfileTable
        :rows="rows"
        :columns="columns"
        :filter="filter"
        :visible-columns="visibleColumns"
        v-model:inputfilter="filter"
        v-model:inputvisible="visibleColumns"
        :add="clickAdd"
        name="ปฏิบัติราชการพิเศษ"
        icon="mdi-bookmark"
        :statusEdit="statusEdit"
      >
        <template #columns="props">
          <q-tr :props="props">
            <q-td
              v-for="col in props.cols"
              :key="col.name"
              :props="props"
              @click="selectData(props)"
              class="cursor-pointer"
            >
              <div
                v-if="
                  col.name == 'dateStart' ||
                  col.name == 'dateEnd' ||
                  col.name == 'refCommandDate'
                "
                class="table_ellipsis"
              >
                {{ col.value ? date2Thai(col.value) : "-" }}
              </div>
              <div v-else class="table_ellipsis">
                {{ col.value ? col.value : "-" }}
              </div>
            </q-td>
            <q-td auto-width>
              <q-btn
                color="info"
                flat
                dense
                round
                size="14px"
                icon="mdi-history"
                @click="clickHistory(props.row)"
              >
                <q-tooltip>ประวัติแก้ไขปฏิบัติราชการพิเศษ </q-tooltip>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </ProfileTable>
    </q-form>
  </q-card>
  <!-- popup Edit window-->
  <q-dialog v-model="modal" persistent>
    <q-card style="width: 600px">
      <q-form ref="myForm">
        <DialogHeader tittle="ปฏิบัติราชการพิเศษ" :close="clickClose" />
        <q-separator />
        <q-card-section class="q-p-sm">
          <div class="row col-12 q-col-gutter-x-xs q-col-gutter-y-xs">
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                v-if="edit"
                outlined
                v-model="inputDateStart"
                label="วันที่เริ่มต้น"
                mask="##/##/####"
                dense
                :error="dayCheckedStart"
                error-message="กรุณากรอกวัน/เดือน/ปี เริ่มต้น"
                :rules="[(val) => !!val || `${'กรุณาเลือกวันที่เริ่มต้น'}`]"
              />

              <datepicker
                v-else
                menu-class-name="modalfix"
                :readonly="!edit"
                v-model="dateStart"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    readonly
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="date2Thai(dateStart)"
                    :rules="[(val) => !!val || `${'กรุณาเลือกวันที่เริ่มต้น'}`]"
                    hide-bottom-space
                    :label="`${'วันที่เริ่มต้น'}`"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                v-if="edit"
                outlined
                v-model="inputDateEnd"
                label="วันที่สิ้นสุด"
                mask="##/##/####"
                dense
                :error="dayCheckedEnd"
                error-message="กรุณากรอกวัน/เดือน/ปี สิ้นสุด"
                :rules="[(val) => !!val || `${'กรุณาเลือกวันที่สิ้นสุด'}`]"
              />
              <datepicker
                v-else
                menu-class-name="modalfix"
                v-model="dateEnd"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                :min-date="minDate"
                :readonly="!edit"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    readonly
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="date2Thai(dateEnd)"
                    :rules="[(val) => !!val || `${'กรุณาเลือกวันที่สิ้นสุด'}`]"
                    hide-bottom-space
                    :label="`${'วันที่สิ้นสุด'}`"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-12">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                autogrow
                :readonly="!edit"
                :borderless="!edit"
                v-model="reference"
                :rules="[(val) => !!val || `${'กรุณากรอกเอกสารอ้างอิง'}`]"
                hide-bottom-space
                :label="`${'เอกสารอ้างอิง'}`"
                @update:modelValue="clickEditRow"
              />
            </div>
            <div class="col-12">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                autogrow
                :readonly="!edit"
                :borderless="!edit"
                v-model="detail"
                :rules="[(val) => !!val || `${'กรุณากรอกรายละเอียด'}`]"
                hide-bottom-space
                :label="`${'รายละเอียด'}`"
                @update:modelValue="clickEditRow"
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="refCommandNo"
                hide-bottom-space
                :label="`${'เลขที่คำสั่ง'}`"
                @update:modelValue="clickEditRow"
              >
                <template v-slot:append>
                  <q-icon
                    name="mdi-file"
                    class="cursor-pointer"
                    @click="resetFilter"
                  />
                </template>
              </q-input>
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                v-if="edit"
                outlined
                v-model="inputRefCommandDate"
                :label="`${'เอกสารอ้างอิง (ลงวันที่)'}`"
                mask="##/##/####"
                dense
                :error="dayCheckedRefCommandDate"
                error-message="กรุณากรอกเอกสารอ้างอิง (ลงวันที่) หรือเว้นว่าง"
              />

              <datepicker
                v-else
                menu-class-name="modalfix"
                :readonly="!edit"
                v-model="refCommandDate"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                @update:modelValue="clickEditRow"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    readonly
                    :class="getClass(edit)"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="
                      refCommandDate == null ? null : date2Thai(refCommandDate as Date)
                    "
                    hide-bottom-space
                    :label="`${'เอกสารอ้างอิง (ลงวันที่)'}`"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        :style="
                          edit
                            ? 'color: var(--q-primary)'
                            : 'color: var(--q-grey)'
                        "
                      >
                      </q-icon>
                    </template>
                    <template v-if="refCommandDate && edit" v-slot:append>
                      <q-icon
                        name="cancel"
                        @click.stop.prevent="refCommandDate = null"
                        class="cursor-pointer"
                      />
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <DialogFooter
          :cancel="clickCancel"
          :edit="clickEdit"
          :save="clickSave"
          :validate="validateData"
          :clickNext="clickNext"
          :clickPrevious="clickPrevious"
          :clickDelete="clickDelete"
          v-model:editvisible="edit"
          v-model:next="next"
          v-model:previous="previous"
          v-model:modalEdit="modalEdit"
        />
      </q-form>
    </q-card>
  </q-dialog>
  <HistoryTable
    :rows="rowsHistory"
    :columns="columnsHistory"
    :filter="filterHistory"
    :visible-columns="visibleColumnsHistory"
    v-model:modal="modalHistory"
    v-model:inputfilter="filterHistory"
    v-model:inputvisible="visibleColumnsHistory"
    v-model:tittle="tittleHistory"
  >
    <template #columns="props">
      <q-tr :props="props">
        <q-td v-for="col in props.cols" :key="col.name" :props="props">
          <div
            v-if="
              col.name == 'dateStart' ||
              col.name == 'dateEnd' ||
              col.name == 'createdAt' ||
              col.name == 'refCommandDate'
            "
            class="table_ellipsis"
          >
            {{ col.value ? date2Thai(col.value) : "-" }}
          </div>
          <div v-else class="table_ellipsis">
            {{ col.value ? col.value : "-" }}
          </div>
        </q-td>
      </q-tr>
    </template>
  </HistoryTable>
</template>
<script setup lang="ts">
import { onMounted, ref, watch } from "vue";
import { useRoute } from "vue-router";
import moment from "moment";
import { useProfileDataStore } from "@/modules/04_registry/store";
import { useCounterMixin } from "@/stores/mixin";
import { validateTime } from "@/modules/04_registry/stores/time";
import ProfileTable from "@/modules/04_registry/components/Table.vue";
import DialogHeader from "@/modules/04_registry/components/DialogHeader.vue";
import DialogFooter from "@/modules/04_registry/components/DialogFooter.vue";
import { useQuasar } from "quasar";
import type {
  RequestItemsObject,
  DataProps,
} from "@/modules/04_registry/interface/request/Work";
import type { ResponseObject } from "@/modules/04_registry/interface/response/Work";
import HistoryTable from "@/components/TableHistory.vue";
import http from "@/plugins/http";
import config from "@/app.config";
import type { QTableProps } from "quasar";

const props = defineProps({
  statusEdit: {
    type: Boolean,
    required: true,
  },
});

const $q = useQuasar();
const store = useProfileDataStore();
const { profileData, changeProfileColumns } = store;

const mixin = useCounterMixin();
const {
  convertDateDisplay,
  convertDate,
  date2Thai,
  success,
  dateToISO,
  messageError,
  showLoader,
  hideLoader,
} = mixin;
const route = useRoute();
const id = ref<string>("");
const dateStart = ref<Date>(new Date());
const dateEnd = ref<Date>(new Date());
const detail = ref<string>();
const reference = ref<string>();
const minDate = ref<Date>();
const refCommandNo = ref<string>();
const refCommandDate = ref<Date | null | string>(new Date());
const myForm = ref<any>(); //form data input
const edit = ref<boolean>(false); //เช็คการกดปุ่มแก้ไขใน dialog
const modal = ref<boolean>(false); //modal add detail
const modalEdit = ref<boolean>(false); //modal ที่แสดงใช้สำหรับแก้ไขหรือไม่
const rawItem = ref<RequestItemsObject>(); //ข้อมูลเดิมที่เลือกใน row นั้น
const rowIndex = ref<number>(0); //indexข้อมูลเดิมที่เลือกใน row นั้น
const previous = ref<boolean>(); //แสดงปุ่มดูข้อมูลก่อนหน้า
const next = ref<boolean>(); //แสดงปุ่มดูข้อมูลต่อไป
const editRow = ref<boolean>(false); //เช็คมีการแก้ไขข้อมูล
const rowsHistory = ref<RequestItemsObject[]>([]); //select data history
const tittleHistory = ref<string>("ประวัติแก้ไขปฏิบัติราชการพิเศษ"); //
const filterHistory = ref<string>(""); //search data table history
const modalHistory = ref<boolean>(false); //modal ประวัติการแก้ไขข้อมูล
const checkValidate = ref<boolean>(false); //validate data ผ่านหรือไม่
const profileId = ref<string>(
  route.params.id ? route.params.id.toString() : ""
);
const rows = ref<RequestItemsObject[]>([]);
const filter = ref<string>(""); //search data table
const visibleColumns = ref<String[]>([]);

console.log(dateStart.value);
const inputDateStart = ref<string>(convertDateDisplay(dateStart.value));
const inputDateEnd = ref<string>(convertDateDisplay(dateEnd.value));
const inputRefCommandDate = ref<string>("");

const dayCheckedStart = ref<boolean>(false);
const dayCheckedEnd = ref<boolean>(false);
const dayCheckedRefCommandDate = ref<boolean>(false);
/** ตรวจเวลา */
watch(
  () => inputDateStart.value,
  (value: string) => {
    if (value.length === 10) {
      const dateVal = convertDate(value);
      if (dateVal.isValid) {
        dayCheckedStart.value = false;
        dateStart.value = new Date(dateVal.value);
      } else {
        dayCheckedStart.value = true;
        inputDateStart.value = "";
      }
    }
  }
);
watch(
  () => inputRefCommandDate.value,
  (value: string) => {
    if (value.length === 10) {
      const dateVal = convertDate(value);
      if (dateVal.isValid) {
        dayCheckedRefCommandDate.value = false;
        refCommandDate.value = new Date(dateVal.value);
      } else {
        dayCheckedRefCommandDate.value = true;
        inputRefCommandDate.value = "";
      }
    } else {
      dayCheckedRefCommandDate.value = false;
      refCommandDate.value = null;
    }
  }
);
watch(
  () => inputDateEnd.value,
  (value: string) => {
    if (value.length === 10) {
      const dateVal = convertDate(value);
      if (dateVal.isValid) {
        dayCheckedEnd.value = false;
        dateEnd.value = new Date(dateVal.value);
      } else {
        dayCheckedEnd.value = true;
        inputDateEnd.value = "";
      }
    }
  }
);

profileData.work.columns.length == 0
  ? (visibleColumns.value = [
      "dateStart",
      "dateEnd",
      "detail",
      "reference",
      "refCommandNo",
      "refCommandDate",
    ])
  : (visibleColumns.value = profileData.work.columns);
const columns = ref<QTableProps["columns"]>([
  {
    name: "dateStart",
    align: "left",
    label: "เริ่มต้น",
    sortable: true,
    field: "dateStart",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "สิ้นสุด",
    sortable: true,
    field: "dateEnd",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "reference",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "reference",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "refCommandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandDate",
    align: "left",
    label: "เอกสารอ้างอิง (ลงวันที่)",
    sortable: true,
    field: "refCommandDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const columnsHistory = ref<QTableProps["columns"]>([
  {
    name: "dateStart",
    align: "left",
    label: "เริ่มต้น",
    sortable: true,
    field: "dateStart",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "สิ้นสุด",
    sortable: true,
    field: "dateEnd",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "reference",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "reference",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "refCommandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandDate",
    align: "left",
    label: "เอกสารอ้างอิง (ลงวันที่)",
    sortable: true,
    field: "refCommandDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "createdFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const visibleColumnsHistory = ref<String[]>([
  "dateStart",
  "dateEnd",
  "detail",
  "reference",
  "refCommandNo",
  "refCommandDate",
  "createdFullName",
  "createdAt",
]);

watch(dateStart, (count, prevCount) => {
  minDate.value = new Date(dateStart.value);
});

watch(visibleColumns, async (count: String[], prevCount: String[]) => {
  await changeProfileColumns("work", count);
});

onMounted(async () => {
  await fetchData();
});

const fetchData = async () => {
  if (profileId.value) {
    showLoader();
    await http
      .get(config.API.profileDutyId(profileId.value))
      .then((res) => {
        let data = res.data.result;
        rows.value = [];
        data.map((e: ResponseObject) => {
          rows.value.push({
            id: e.id,
            dateStart: new Date(e.dateStart),
            dateEnd: new Date(e.dateEnd),
            detail: e.detail,
            reference: e.reference,
            refCommandNo: e.refCommandNo,
            refCommandDate:
              e.refCommandDate == null ? null : new Date(e.refCommandDate),
            createdFullName: e.createdFullName,
            createdAt: new Date(e.createdAt),
          });
        });
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        store.isLoad++;
      });
  }
};

/**
 * กดดูข้อมูลก่อนหน้า
 */
const clickPrevious = async () => {
  edit.value = false;
  rowIndex.value -= 1;
  await getData();
  await checkRowPage();
};

/**
 * กดดูข้อมูลต่อไป
 */
const clickNext = async () => {
  edit.value = false;
  rowIndex.value += 1;
  await getData();
  await checkRowPage();
};

/**
 * กดดูข้อมูลต่อไป
 */
const getData = () => {
  const row = rows.value[rowIndex.value];
  dateStart.value = row.dateStart;
  dateEnd.value = row.dateEnd;
  detail.value = row.detail;
  reference.value = row.reference;
  refCommandNo.value = row.refCommandNo;
  refCommandDate.value =
    row.refCommandDate == "-" ? "" : (row.refCommandDate as Date);
  id.value = row.id;
};

/**
 * เช็คปุ่มดูข้อมูล ย้อน กับ ต่อไป ว่าต้องแสดงไหม
 */
const checkRowPage = () => {
  editRow.value = false;
  next.value = true;
  previous.value = true;
  if (rowIndex.value + 1 >= rows.value.length) {
    next.value = false;
  }
  if (rowIndex.value - 1 < 0) {
    previous.value = false;
  }
};

/**
 * กดปุ่มแก้ไขใน dialog
 */
const clickEdit = () => {
  editRow.value = false;
  next.value = false;
  previous.value = false;
};

/**
 * กดปุ่มเพิ่มด้านบน table
 */
const clickAdd = async () => {
  editRow.value = false;
  await addData();
};

/**
 * กดบันทึกใน dialog
 */
const clickSave = async () => {
  dayCheckedStart.value = validateTime(inputDateStart.value);
  dayCheckedEnd.value = validateTime(inputDateEnd.value);
  dayCheckedRefCommandDate.value = validateTime(inputRefCommandDate.value);

  if (
    dayCheckedStart.value ||
    dayCheckedEnd.value ||
    dayCheckedRefCommandDate.value
  )
    return;
  myForm.value.validate().then(async (result: boolean) => {
    if (result) {
      if (modalEdit.value) {
        await editData();
      } else {
        await saveData();
      }
    }
  });
};

/**
 * บันทึกเพิ่มข้อมูล
 */
const saveData = async () => {
  if (profileId.value) {
    showLoader();
    await http
      .post(config.API.profileDutyId(profileId.value), {
        id: id.value,
        dateStart: dateToISO(dateStart.value),
        dateEnd: dateToISO(dateEnd.value),
        detail: detail.value,
        reference: reference.value,
        refCommandNo: refCommandNo.value,
        refCommandDate:
          refCommandDate.value == null
            ? null
            : dateToISO(refCommandDate.value as Date),
      })
      .then((res) => {
        success($q, "บันทึกข้อมูลสำเร็จ");
        modal.value = false;
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(async () => {
        await fetchData();
      });
  }
};

/**
 * บันทึกแก้ไขข้อมูล
 */
const editData = async () => {
  showLoader();
  await http
    .put(config.API.profileDutyId(id.value), {
      id: id.value,
      dateStart: dateToISO(dateStart.value),
      dateEnd: dateToISO(dateEnd.value),
      detail: detail.value,
      reference: reference.value,
      refCommandNo: refCommandNo.value,
      refCommandDate:
        refCommandDate.value == null
          ? null
          : dateToISO(refCommandDate.value as Date),
    })
    .then((res) => {
      success($q, "บันทึกข้อมูลสำเร็จ");
      modal.value = false;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      await fetchData();
    });
};

/**
 * ลบลบข้อมูล
 */
const clickDelete = async () => {
  $q.dialog({
    title: `ลบข้อมูล`,
    message: `ต้องการทำการลบข้อมูลนี้ใช่หรือไม่?`,
    cancel: "ยกเลิก",
    ok: "ยืนยัน",
    persistent: true,
  })
    .onOk(async () => {
      showLoader();
      await http
        .delete(config.API.profileDutyId(id.value))
        .then((res) => {
          success($q, "ลบข้อมูลสำเร็จ");
          modal.value = false;
        })
        .catch((e) => {
          messageError($q, e);
        })
        .finally(async () => {
          await fetchData();
        });
    })
    .onCancel(async () => {
      await fetchData();
    });
};

/**
 * กดปิด dialog
 */
const clickClose = async () => {
  if (editRow.value == true) {
    $q.dialog({
      title: `ข้อมูลมีการแก้ไข`,
      message: `ยืนยันที่จะปิดโดยไม่บันทึกใช่หรือไม่?`,
      cancel: "ยกเลิก",
      ok: "ยืนยัน",
      persistent: true,
    }).onOk(async () => {
      modal.value = false;
      next.value = false;
      previous.value = false;
    });
  } else {
    modal.value = false;
    next.value = false;
    previous.value = false;
    dayCheckedStart.value = false;
    dayCheckedEnd.value = false;
    dayCheckedRefCommandDate.value = false;
  }
};

/**
 * กดเลือกข้อมูลที่จะแก้ไข
 * @param props ค่า props ใน row ที่เลือก
 */
const selectData = async (props: DataProps) => {
  modalEdit.value = true;
  modal.value = true;
  edit.value = false;
  rawItem.value = props.row;
  rowIndex.value = props.rowIndex;
  dateStart.value = props.row.dateStart;
  dateEnd.value = props.row.dateEnd;
  detail.value = props.row.detail;
  reference.value = props.row.reference;
  refCommandNo.value = props.row.refCommandNo;
  refCommandDate.value =
    props.row.refCommandDate == "-" ? "" : (props.row.refCommandDate as Date);
  id.value = props.row.id;

  inputDateStart.value = convertDateDisplay(dateStart.value);
  inputDateEnd.value = convertDateDisplay(dateEnd.value);
  inputRefCommandDate.value = refCommandDate.value
    ? convertDateDisplay(refCommandDate.value as Date)
    : "";
  await checkRowPage();
};

/**
 * กดปุ่มเพิ่มบน table
 */
const addData = () => {
  modalEdit.value = false;
  modal.value = true;
  edit.value = true;
  dateStart.value = new Date();
  dateEnd.value = new Date();
  detail.value = "";
  reference.value = "";
  refCommandNo.value = "";
  refCommandDate.value = null;

  inputDateStart.value = convertDateDisplay(dateStart.value);
  inputDateEnd.value = convertDateDisplay(dateEnd.value);
  inputRefCommandDate.value = "";
};

/**
 * ฟังก์ชันปุ่มยกเลิกการแก้ไขข้อมูล
 */
const clickCancel = async () => {
  if (editRow.value == true) {
    $q.dialog({
      title: `ข้อมูลมีการแก้ไข`,
      message: `ยืนยันยกเลิกการแก้ไขใช่หรือไม่?`,
      cancel: "ยกเลิก",
      ok: "ยืนยัน",
      persistent: true,
    }).onOk(async () => {
      edit.value = false;
      await checkRowPage();
      await getData();
    });
  } else {
    edit.value = false;
    await checkRowPage();
  }
};

/**
 * เช็คว่ามีการแก้ไขข้อมูล
 */
const clickEditRow = () => {
  editRow.value = true;
};

/**
 * ฟังชั้นดูข้อมูลประวัติแก้ไขข้อมูลที่เลือก
 * @param row ข้อมูล row ที่ดูประวัติการแก้ไข
 */
const clickHistory = async (row: RequestItemsObject) => {
  modalHistory.value = true;
  filterHistory.value = "";
  showLoader();
  await http
    .get(config.API.profileDutyHisId(row.id))
    .then((res) => {
      let data = res.data.result;
      rowsHistory.value = [];
      data.map((e: ResponseObject) => {
        rowsHistory.value.push({
          id: e.id,
          dateStart: new Date(e.dateStart),
          dateEnd: new Date(e.dateEnd),
          detail: e.detail,
          reference: e.reference,
          refCommandNo: e.refCommandNo,
          refCommandDate:
            e.refCommandDate == null ? null : new Date(e.refCommandDate),
          createdFullName: e.createdFullName,
          createdAt: new Date(e.createdAt),
        });
      });
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

/**
 * validate input ใน dialog
 */
const validateData = async () => {
  checkValidate.value = true;
  await myForm.value.validate().then((result: boolean) => {
    if (result == false) {
      checkValidate.value = false;
    }
  });
};

/**
 * class จัดรูปแบบแสดงระหว่างข้อมูลที่แก้ไขหรือแสดงเฉยๆ
 * @param val ข้อมูล input สำหรับแก้ไขหรือไม่
 */
const getClass = (val: boolean) => {
  return {
    "full-width inputgreen cursor-pointer": val,
    "full-width cursor-pointer": !val,
  };
};
const resetFilter = () => {};
</script>
<style lang="scss">
.modalfix {
  position: fixed !important;
}
</style>
